<template>
  <div class="row">
    <fieldset class="border">
      <legend class="w-auto" style="margin-top: -11px; background-color: white;">
        <b>Historial de visados</b>
      </legend>
      <div class="col">
        <div class="row justify-content-center">
          <div class="col-10">
            <table class="table table-striped" v-if="visadosHistStore.getVisadosHist().length > 0">
              <thead>
                <tr class="bg-principal text-light fs-4 text-uppercase">
                  <th scope="col" style="padding: 15px 10px !important">Visado</th>
                  <th scope="col" style="padding: 15px 10px !important">Visador</th>
                  <th scope="col" style="padding: 15px 10px !important">V&aacute;lido Desde</th>
                  <th scope="col" style="padding: 15px 10px !important">F. Vencimiento</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="visadoHist in visadosHistStore.getVisadosHist()" :key="visadoHist.id_beca_historico">
                  <td class="pt-2 pb-1 px-2 text-center" v-text='visadoHist.visado'></td>
                  <td class="pt-2 pb-1 px-2 text-center" v-text='visadoHist.visador'></td>
                  <td class="pt-2 pb-1 px-2 text-center" v-text='visadoHist.f_visado'></td>
                  <td class="pt-2 pb-1 px-2 text-center" v-text='visadoHist.f_vencim_v'></td>
                </tr>
              </tbody>
            </table>
            <div v-else class="alert alert-secondary text-center" role="alert">
              No se ha encontrado ning&uacute;n visado hist&oacute;rico de esta beca en el sistema.
            </div>
          </div>
        </div>
      </div>
    </fieldset>
  </div>
</template>

<script setup lang="ts">
// Librerías
import { onMounted, reactive, computed, watch } from "vue";
import type { PropType } from "vue";
import { DateTime } from "luxon";
import { loading } from "@/shared.js";
// Entidades
// import type VisadoHist from "@/entities/becas/VisadoHist";
// Stores
import { useVisadosHistStore } from "@/stores/becas/visadosHist";

//const aynMostrar = (cupo: Cupo) => cupo.apellido + ' ' + cupo.nombres;
//const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
//const importeMostrar = (importe: number) => Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe);

const visadosHistStore = useVisadosHistStore();

const props = withDefaults(defineProps<{
  idBeca: number,
  verHistorial: boolean
}>(), {
  idBeca: NaN,
  verHistorial: false
});

const verHistorial = computed(() => props.verHistorial);

watch(verHistorial, async (newValue, oldValue) => {
  if (newValue !== oldValue && newValue) {
    loading.show();
    await visadosHistStore.fetchVisadosHist({ id_beca: props.idBeca });
    loading.hide();
  }
});

</script>
